#! /bin/bash

ROOTDIR=${ROOTDIR:-`bzr root`}
if [ ! -d "$ROOTDIR"  ]; then
    echo "ROOTDIR '$ROOTDIR' doesn't exist" >&2
    exit 1
fi

if [ -d /usr/lib/postgresql/8.4 ]; then
    PGBINDIR=/usr/lib/postgresql/8.4/bin
elif [ -d /usr/lib/postgresql/8.3 ]; then
    PGBINDIR=/usr/lib/postgresql/8.3/bin
else
    echo "Cannot find valid parent for PGBINDIR"
fi

# setting PGDATA tells pg_ctl which DB to talk to
export PGDATA=$ROOTDIR/tmp/db1/data/
$PGBINDIR/pg_ctl status > /dev/null
if [ $? = 0 ]; then
    $PGBINDIR/pg_ctl stop -t 60 -w -m fast
fi
