from zope.interface import implements

from twisted.plugin import IPlugin
from txstatsd.itxstatsd import IMetricFactory
from distinctdb.distinctmetric import DistinctMetricReporter, ONE_DAY


class DistinctMetricFactory(object):
    implements(IMetricFactory, IPlugin)

    name = "distinct"
    metric_type = "d"

    bucket_size = None
    dsn = None
    metric_ids = None

    def build_metric(self, prefix, name, wall_time_func=None):
        return DistinctMetricReporter(name, prefix=prefix,
                                      wall_time_func=wall_time_func,
                                      bucket_size=self.bucket_size,
                                      dsn=self.dsn, redis_host=self.redis_host,
                                      redis_port=self.redis_port)

    def configure(self, options):
        self.section = dict(options.get("plugin_distinctdb", {}))
        try:
            self.bucket_size = int(self.section.get("bucket_size", ONE_DAY))
        except ValueError:
            self.bucket_size = ONE_DAY

        self.dsn = self.section.get("dsn", None)
        self.redis_host = self.section.get("redis_host", None)
        self.redis_port = self.section.get("redis_port", None)
        if self.redis_port is not None:
            self.redis_port = int(self.redis_port)

distinct_metric_factory = DistinctMetricFactory()
